/*
 * Created on July 19st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */

import 'package:args/command_runner.dart';
import 'package:azure_application_insights/azure_application_insights.dart';
import 'package:welltested/src/utilities/command_runner.dart';
import 'package:welltested/src/utilities/logging.dart';
import 'package:welltested/src/utilities/telemetry_client.dart';

void main(List<String> args) async {
  var runner = CommandRunner("welltested",
      "Welltested auto generates to auto generate tests for your code with AI within minutes.")
    ..addCommand(GenerateCommmand())
    ..addCommand(SaveCommand())
    ..addCommand(InitCommand());

  try {
    await runner.run(args);
  } catch (e, stackTrace) {
    wtTelemetry.trackError(
        severity: Severity.critical, error: e, stackTrace: stackTrace);
    if (e is UsageException) {
      wtLog.error(e.message);
      wtLog.log(e.usage);
      return;
    }
    wtLog.error(e.toString());
    wtLog.info(stackTrace.toString(), verbose: true);
  } finally {
    await wtTelemetry.flush();
  }
}
