/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analyzer/dart/ast/ast.dart';
import 'package:analyzer/dart/element/element.dart';
import 'package:welltested/src/visitors/class_visitor.dart';

import '../utilities/utilities.dart';

class AstElementExecutor {
  Future<Map<String, MethodDeclaration>> methodNodesFromElement(
      Element element) async {
    final classVisitor = ClassVisitor();
    final Map<String, MethodDeclaration> methodAstNodes = {};
    element.visitChildren(classVisitor);
    for (final method in classVisitor.methods.entries) {
      final node = (await getResolvedAstNodeForElement(method.value))
          as MethodDeclaration;
      methodAstNodes[method.key] = node;
    }
    return methodAstNodes;
  }
}
