/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analysis_server_lib/analysis_server_lib.dart';

extension AnalysisErrorExtension on List<AnalysisError> {
  List<AnalysisError> get fixableUndefinedErrors {
    List<AnalysisError> analysisErrors = [];
    forEach((error) {
      if ((error.code == "undefined_identifier" ||
              error.code == "undefined_class" ||
              error.code == "undefined_function" ||
              error.code == "undefined_annotation" ||
              error.code == "undefined_enum") &&
          (error.hasFix ?? false)) {
        if (analysisErrors.indexWhere((element) =>
                (element.code + element.message) ==
                (error.code + error.message)) ==
            -1) {
          analysisErrors.add(error);
        }
      }
    });
    return analysisErrors;
  }
}
