import 'package:analyzer/dart/ast/ast.dart';
import 'package:analyzer/dart/element/element.dart';
import 'package:welltested_annotation/welltested_annotation.dart';

extension ElementAnnotationExt on ElementAnnotation {
  List<String> get excludeMethods => computeConstantValue()!
      .getField("excludedMethods")!
      .toListValue()!
      .map((e) => e.toStringValue()!)
      .toList();
}

extension AnnotationExt on NodeList<Annotation> {
  List<Annotation> get packageAnnotations {
    return welltestedAnnotations + testcasesAnnotations;
  }

  List<Annotation> get welltestedAnnotations {
    return where((element) =>
        element.name.name == Welltested().runtimeType.toString()).toList();
  }

  List<Annotation> get testcasesAnnotations {
    return where((element) =>
        element.name.name == Testcases([]).runtimeType.toString()).toList();
  }
}
