import 'package:analyzer/dart/ast/ast.dart';
import 'package:analyzer/dart/element/element.dart';
import 'package:welltested/src/utilities/utilities.dart';

extension ExtElementExtension on ExtensionElement {
  Future<Map<String, MethodDeclaration>> get getMethodDeclarations async {
    final Map<String, MethodDeclaration> methodAstNodes = {};
    for (final method in methods) {
      final node =
          (await getResolvedAstNodeForElement(method)) as MethodDeclaration;
      methodAstNodes[method.name] = node;
    }
    return methodAstNodes;
  }
}
