import 'dart:io';
import 'package:analyzer/dart/analysis/results.dart';
import 'package:path/path.dart' as p;
import 'package:analyzer/dart/analysis/analysis_context_collection.dart';
import 'package:welltested_annotation/welltested_annotation.dart';

@Welltested()
extension FileResolution on FileSystemEntity {
  Future<ResolvedUnitResult> resolveFile(
    AnalysisContextCollection collection,
  ) async {
    final absoluteNormlizedPath = p.normalize(this.absolute.path);
    final context = collection.contextFor(absoluteNormlizedPath);
    return (await context.currentSession.getResolvedUnit(absoluteNormlizedPath))
        as ResolvedUnitResult;
  }
}
