import 'dart:convert';

import 'package:welltested/src/models/dependency_info.dart';
import 'package:welltested/src/models/pubspec_data.dart';

extension PubspecDataExt on PubspecData {
  DependencyInfo? get welltestedInfo {
    if (this.dev_dependencies?.containsKey('welltested') ?? false)
      return DependencyInfo(
          'welltested', jsonEncode(this.dev_dependencies?['welltested']),
          dev: true);
    if (this.dependencies?.containsKey('welltested') ?? false)
      return DependencyInfo(
          'welltested', jsonEncode(this.dependencies?['welltested']),
          dev: true);
    return null;
  }
  
  DependencyInfo? get welltestedAnnotationInfo{
    if (this.dev_dependencies?.containsKey('welltested_annotation') ?? false)
      return DependencyInfo(
          'welltested_annotation', jsonEncode(this.dev_dependencies?['welltested_annotation']),
          dev: true);
    if (this.dependencies?.containsKey('welltested_annotation') ?? false)
      return DependencyInfo(
          'welltested_annotation', jsonEncode(this.dependencies?['welltested_annotation']),
          dev: false);
    return null;
  }

  DependencyInfo? get build_runnerInfo{
    if (this.dev_dependencies?.containsKey('build_runner') ?? false)
      return DependencyInfo(
          'build_runner', jsonEncode(this.dev_dependencies?['build_runner']),
          dev: true);
    if (this.dependencies?.containsKey('build_runner') ?? false)
      return DependencyInfo(
          'build_runner', jsonEncode(this.dependencies?['build_runner']),
          dev: false);
    return null;
  }
  
  DependencyInfo? get mockitoInfo{
    if (this.dev_dependencies?.containsKey('mockito') ?? false)
      return DependencyInfo(
          'mockito', jsonEncode(this.dev_dependencies?['mockito']),
          dev: true);
    if (this.dependencies?.containsKey('mockito') ?? false)
      return DependencyInfo(
          'mockito', jsonEncode(this.dependencies?['mockito']),
          dev: false);
    return null;
  }

  DependencyInfo? get flutterTestInfo{
    if (this.dev_dependencies?.containsKey('flutter_test') ?? false)
      return DependencyInfo(
          'flutter_test', jsonEncode(this.dev_dependencies?['flutter_test']),
          dev: true);
    if (this.dependencies?.containsKey('flutter_test') ?? false)
      return DependencyInfo(
          'flutter_test', jsonEncode(this.dependencies?['flutter_test']),
          dev: false);
    return null;
  }

  DependencyInfo? get testInfo{
    if (this.dev_dependencies?.containsKey('test') ?? false)
      return DependencyInfo(
          'test', jsonEncode(this.dev_dependencies?['test']),
          dev: true);
    if (this.dependencies?.containsKey('test') ?? false)
      return DependencyInfo(
          'test', jsonEncode(this.dependencies?['test']),
          dev: false);
    return null;
  }
}
