enum TestGenerationStatus { create, update, forceUpdate, omit, failed }

class TestRunInfo {
  int created;
  int updated; //used in both generate and save
  int ommitted;
  int failed;

  TestRunInfo(this.created, this.updated, this.ommitted, this.failed);

  factory TestRunInfo.newRun() => TestRunInfo(0, 0, 0, 0);

  void incrementFromAction(TestGenerationStatus status) {
    switch (status) {
      case TestGenerationStatus.create:
        created++;
        break;
      case TestGenerationStatus.update:
        updated++;
        break;
      case TestGenerationStatus.forceUpdate:
        created++;
        break;
      case TestGenerationStatus.omit:
        ommitted++;
        break;
      case TestGenerationStatus.failed:
        failed++;
        break;
    }
  }
}
