/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'dart:io';
import 'package:path/path.dart' as p;
// import 'package:build/build.dart';

class PathUtils {
  static File correspondingPermanentTestFile(
      String functionName, File classFile) {
    final uri = Uri.file(
        testPath +
            '/' +
            relatetiveLibFilePath(classFile.path).replaceAll(".dart", "") +
            "/$functionName" +
            ".welltested_test.dart",
        windows: Platform.isWindows);
    return File.fromUri(uri);
  }

  static String get currentPath => Directory.current.path;
  static String get libPath => p.join(currentPath, 'lib');
  static String get testPath => p.join(currentPath, 'test');
  static String get integrationTest => p.join(currentPath, 'integration_test');

  static String relatetiveLibFilePath(String filePath) =>
      p.relative(filePath, from: libPath);
  static String relativeTestFilePath(String filePath) =>
      p.relative(filePath, from: testPath);

  static String absouteLibFilePath(String relativePath) =>
      p.join(libPath + '/' + relativePath);
  static String absouteTestFilePath(String relativePath) =>
      p.join(testPath + '/' + relativePath);
}
