import 'dart:io';

import 'package:azure_application_insights/azure_application_insights.dart';
import 'package:http/http.dart' as http;

const instrumentationKey = 'becbb0d5-e2db-44a1-bccb-16e12abd6aea';
final processor = BufferedProcessor(
  next: TransmissionProcessor(
    instrumentationKey: instrumentationKey,
    httpClient: http.Client(),
    timeout: const Duration(seconds: 10),
  ),
);

final wtTelemetry = TelemetryClient(processor: processor)
  ..context.device.type = Platform.operatingSystem;

void setPackage(String? version, bool? dev) {
  wtTelemetry.context.applicationVersion = version;
  wtTelemetry.context.properties['dev'] = dev;
}
