/*
 * Created on May 1st 2023
 *
 * Copyright (C) 2023 Welltested AI - All Rights Reserved
 * The code in this file is Intellectutal Property of Welltested AI.
 * and can't be edited, redistributed or used without a valid license of it's product (Welltested)[https://welltested.ai]
 */
import 'package:analyzer/dart/ast/ast.dart';
import 'package:analyzer/dart/ast/visitor.dart';

class ReplaceModel {
  final int offset;
  final int length;
  final String orignalText;
  final String replacement;
  final String replacementReason;
  const ReplaceModel(
      {required this.offset,
      required this.length,
      required this.orignalText,
      required this.replacement,
      this.replacementReason = ''});
  int get endOffset => offset + length;
}

class UnitTestVisitor extends RecursiveAstVisitor {
  final List<ReplaceModel> replacements = [];

  @override
  visitVariableDeclarationStatement(VariableDeclarationStatement node) {
    final declaration = node.toSource();
    if (!declaration.contains("=")) {
      replacements.add(ReplaceModel(
          offset: node.offset,
          length: node.length,
          orignalText: declaration,
          replacement: "late " + declaration,
          replacementReason: "late_modifier_for_uninitialized"));
    }
    return super.visitVariableDeclarationStatement(node);
  }
}
